package com.zhongzheng.modules.user.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;
import com.zhongzheng.modules.user.bo.UserPlanCourceAddBo;
import com.zhongzheng.modules.user.bo.UserPlanCourceQueryBo;
import com.zhongzheng.modules.user.bo.UserPlanCourceEditBo;
import com.zhongzheng.modules.user.domain.UserPlanCource;
import com.zhongzheng.modules.user.mapper.UserPlanCourceMapper;
import com.zhongzheng.modules.user.vo.UserPlanCourceVo;
import com.zhongzheng.modules.user.service.IUserPlanCourceService;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 学习计划绑定课程Service业务层处理
 *
 * @author ruoyi
 * @date 2021-12-08
 */
@Service
public class UserPlanCourceServiceImpl extends ServiceImpl<UserPlanCourceMapper, UserPlanCource> implements IUserPlanCourceService {

    @Override
    public UserPlanCourceVo queryById(Long planId){
        UserPlanCource db = this.baseMapper.selectById(planId);
        return BeanUtil.toBean(db, UserPlanCourceVo.class);
    }

    @Override
    public List<UserPlanCourceVo> queryList(UserPlanCourceQueryBo bo) {
        LambdaQueryWrapper<UserPlanCource> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getPlanId() != null, UserPlanCource::getPlanId, bo.getPlanId());
        lqw.eq(bo.getSourceId() != null, UserPlanCource::getSourceId, bo.getSourceId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<UserPlanCourceVo> entity2Vo(Collection<UserPlanCource> collection) {
        List<UserPlanCourceVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, UserPlanCourceVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<UserPlanCource> page = (Page<UserPlanCource>)collection;
            Page<UserPlanCourceVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(UserPlanCourceAddBo bo) {
        UserPlanCource add = BeanUtil.toBean(bo, UserPlanCource.class);
        validEntityBeforeSave(add);
        add.setCreateTime(DateUtils.getNowTime());
        add.setUpdateTime(DateUtils.getNowTime());
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(UserPlanCourceEditBo bo) {
        UserPlanCource update = BeanUtil.toBean(bo, UserPlanCource.class);
        validEntityBeforeSave(update);
        update.setUpdateTime(DateUtils.getNowTime());
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(UserPlanCource entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
